Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# MutexDirect Class Reference

This class implements a standard mutex by making direct calls to the underlying implementation layer. More...

Inheritance diagram for MutexDirect:

List of all members.

## Public Member Functions
| acquire ()
| Grabs the mutex if it is available.
| clearName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | debugIsLocked ()
| Returns true if the current thread has locked the Mutex, false otherwise.
string | getName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | hasName ()
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
| output (ostream out)
| This method is declared virtual in MutexDebug, but non-virtual in MutexDirect.
| release ()
| Releases the mutex.
| setName (string name)
| The mutex name is only defined when compiling in DEBUG_THREADS mode.
bool | tryAcquire ()
| Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

## Detailed Description

This class implements a standard mutex by making direct calls to the underlying implementation layer.

It doesn't perform any debugging operations.

## Member Function Documentation

acquire | ( |  | ) |

Grabs the mutex if it is available.

If it is not available, blocks until it becomes available, then grabs it. In either case, the function does not return until the mutex is held; you should then call unlock().

This method is considered const so that you can lock and unlock const mutexes, mainly to allow thread-safe access to otherwise const data.

Also see MutexHolder.

clearName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool debugIsLocked | ( |  | ) |

Returns true if the current thread has locked the Mutex, false otherwise.

This method is only intended for use in debugging, hence the method name; in the MutexDirect case, it always returns true, since there's not a reliable way to determine this otherwise.

string getName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool hasName | ( |  | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

output | ( | ostream | out | ) |

This method is declared virtual in MutexDebug, but non-virtual in MutexDirect.

release | ( |  | ) |

Releases the mutex.

It is an error to call this if the mutex was not already locked.

This method is considered const so that you can lock and unlock const mutexes, mainly to allow thread-safe access to otherwise const data.

setName | ( | string | name | ) |

The mutex name is only defined when compiling in DEBUG_THREADS mode.

bool tryAcquire | ( |  | ) |

Returns immediately, with a true value indicating the mutex has been acquired, and false indicating it has not.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties